/* jshint undef: true */

function cgUrl() {

}

cgUrl.URL_DOT = '.';
cgUrl.URL_DOT_DOT = '..';
cgUrl.URL_DOT_DOT_SLASH = '../';
cgUrl.URL_HASH = '#';
cgUrl.URL_QUESTION = '?';
cgUrl.URL_SLASH = '/';
cgUrl.EMPTY_STRING = '';

cgUrl.urlJoin = function(base, url) {

    if (url.substring(0, 1) === '/') { // url is already an /absolute-path
        return url;
    } else {
        var path = base.split(cgUrl.URL_QUESTION)[0];
        return _normalizePath(path.substring(0, path.lastIndexOf(cgUrl.URL_SLASH) + 1) + url);
    }

    function _normalizePath(path) {
        var pathParts, pathPart, pathStack, normalizedPath;

        if (path.indexOf(cgUrl.URL_DOT_DOT_SLASH) === -1) {
            normalizedPath = path;
        } else {
            pathParts = path.split(cgUrl.URL_SLASH);
            pathStack = [];
            for (var i = 0, len = pathParts.length; i < len; i++) {
                pathPart = pathParts[i];
                if (pathPart === cgUrl.URL_DOT_DOT) {
                    pathStack.pop();
                } else if (pathPart && pathPart !== cgUrl.URL_DOT) {
                    pathStack.push(pathPart);
                }
            }
            if (path[0] === cgUrl.URL_SLASH) {
                pathStack.unshift(cgUrl.EMPTY_STRING);
            }
            if (path[path.length - 1] === cgUrl.URL_SLASH && pathStack.length > 1) {
                pathStack.push(cgUrl.EMPTY_STRING);
            }
            normalizedPath = pathStack.join(cgUrl.URL_SLASH);
        }
        return normalizedPath;
    }
};
