// ================================================== //
//    Contact Center Display Call interface module    //
//                     Version 2.2.5                  //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

function displayCall(callID) {
  var maxNumLength = 20;
  if(!monitorData.call[callID]) {
    return;
  }
  // remove old peers
  if(monitorData.call[callID].oldPeers) {
    // check listeners
    var noear;
    var totalNoear;
    var iKey;
    var jKey;
    var oldPeers = Object.keys(monitorData.call[callID].oldPeers);
    for(var i = 0; i < oldPeers.length; ++i) {
      iKey = oldPeers[i];
      if(monitorData.call[callID].oldPeers[iKey].type == 'listener' && monitorData.call[callID].oldPeers[iKey].name == sessionParams.name) {
        noear = monitorData.call[callID].oldPeers[iKey].mode;
        if(!monitorData.call[callID].peers[iKey]) {
          // ear disappeared
          totalNoear = noear;
        }
        break;
      }
    }
    // check old peers
    for(var i = 0; i < oldPeers.length; ++i) {
      iKey = oldPeers[i];
      var oldPeer = monitorData.call[callID].oldPeers[iKey];
      if(!monitorData.call[callID].peers[iKey]) {
        // peer disappeared
        if(oldPeer.isAgent && monitorData.agent[oldPeer.name]) {
          // remove call from agent
          var ac = $('#monContainer .items li[data-value="' + oldPeer.name + '"] .lines');
          if(oldPeer.name == sessionParams.name) {
            ac = $('#monContainer .items li[data-value="' + oldPeer.name + '"] .lines, #selfLines');
            if(mute == callID) mute = null;
            if(refer == callID) refer = null;
            if(onservice == callID) onservice = null;
            updateActionButtons();
          }
          ac.find('span[data-value="' + callID + '"]').remove();
          // <cg-agents>
          $('#cga div[data-value="' + oldPeer.name + '"] .call span[data-value="' + callID + '"]').remove();
          $('#cga div[data-value="' + oldPeer.name + '"] .busyTime').attr('data-value', '');
          $('#cga div[data-value="' + oldPeer.name + '"] .status').attr('data-value', '');
          $('#cga div[data-value="' + oldPeer.name + '"] .status').text(monitorData.agent[oldPeer.name].statusInfo ?
              monitorData.agent[oldPeer.name].statusInfo : translate(['agentStatus', monitorData.agent[oldPeer.name].status]));
          $('#cga div[data-value="' + oldPeer.name + '"] .icon').removeClass().addClass('icon').addClass(monitorData.agent[oldPeer.name].status);
          // </cg-agents>
          if(!ac.children('span.connected').length && !ac.children('span.out').length) {
            if(oldPeer.state != 'connecting' && oldPeer.state != 'provisioned' && oldPeer.type != 'listener') {
              for(var j = 0; j < monitorData.agent[oldPeer.name].groups.length; j++) {
                monitorData.group[monitorData.agent[oldPeer.name].groups[j]].busy--;
                updateMonGroupHead(monitorData.agent[oldPeer.name].groups[j]);
              }
            }
          }
          if(!ac.children().length) {
            //ac.siblings('.select').show();
            ac.siblings('.tStatusModified').show();
          }
          if(noear) {
            $('#monContainer .items li[data-value="' + oldPeer.name + '"] .listener[data-value="' + noear + '"]').removeClass('active');
          }
        }
        // remove peer from sausages
        $('a[data-value="' + i + '"]').remove();
      } else {
        if(totalNoear) {
          $('#monContainer .items li[data-value="' + oldPeer.name + '"] .listener[data-value="' + totalNoear + '"]').removeClass('active');
        }
      }
    }
  }
  // handle new peers and old peer updates
  if(monitorData.call[callID].peers) {
    // handle listeners
    var ear;
    var peers = Object.keys(monitorData.call[callID].peers);
    for(var i = 0; i < peers.length; ++i) {
      iKey = peers[i];
      if(monitorData.call[callID].peers[iKey].type == 'listener' && monitorData.call[callID].peers[iKey].name == sessionParams.name) {
          ear = monitorData.call[callID].peers[iKey].mode;
        break;
      }
    }
    // handle peers
    var via = getCallVia(monitorData.call[callID]);
    for(var i = 0; i < peers.length; ++i) {
      iKey = peers[i];
      var sc = null;
      var peer = monitorData.call[callID].peers[iKey];
      if(peer.type == 'listener') {
        continue;
      }
      if(monitorData.call[callID].oldPeers) {
        if(monitorData.call[callID].oldPeers[iKey]) {
          if(monitorData.call[callID].oldPeers[iKey].state == peer.state && getKeysCount(monitorData.call[callID].oldPeers) == getKeysCount(monitorData.call[callID].peers) && monitorData.call[callID].oldPeers[iKey].qName == peer.qName && monitorData.call[callID].oldPeers[iKey].muteMode == peer.muteMode) {
            if(ear) {
              $('#monContainer .items li[data-value="' + peer.name + '"] .listener[data-value="' + ear + '"]').addClass('active').siblings('.active').removeClass('active');
        }
            continue;
          }
        }
      }
      if(peer.isAgent && monitorData.agent[peer.name]) {
        // display agent calls
        var ac = $('#monContainer .items li[data-value="' + peer.name + '"] .lines');
        if(peer.name == sessionParams.name) {
          ac = $('#monContainer .items li[data-value="' + peer.name + '"] .lines, #selfLines');
        }
        // <cg-agents>
        var cgac = $('#cga div[data-value="' + peer.name + '"]');
        // </cg-agents>
        if(peer.state == 'onservice' && peer.name == sessionParams.name) {
          onservice = callID;
        } else if(peer.name == sessionParams.name) {
          if(onservice == callID) {
            onservice = null;
          }
        }
        if(peer.type == 'refer' && peer.name == sessionParams.name) {
          refer = callID;
        } else if(peer.name == sessionParams.name) {
          if(refer == callID) {
            refer = null;
          }
        }
        if(peer.muteMode && peer.name == sessionParams.name) {
          mute = callID;
        } else if(peer.name == sessionParams.name) {
          if(mute == callID) {
            mute = null;
          }
        }
        updateActionButtons();
        var peerList = '';
        if(peer.qName) {
          if(peer.state != 'inqueue') {
            if(peer.type == 'refer' && peer.referredBy) {
              // display referred by
              peerList += '<a data-value="' + peer.referredBy + '"' + (via ? ' title="' + via + '"' : '') +
                '>' + getUserPart(monitorData.call[callID].peers[peer.referredBy].name, maxNumLength) + '</a>';
            } else {
              for(var j = 0; j < peers.length; ++j) {
                jKey = peers[j];
                if(monitorData.call[callID].peers[jKey].state == 'inqueue') {
                  peerList += '<a data-value="' + jKey + '"' + (via ? ' title="' + via + '"' : '') +
                    '>' + getUserPart(monitorData.call[callID].peers[jKey].name, maxNumLength) + '</a>';
                }
              }
            }
          } else {
            peerList = '<a>' + getUserPart(peer.qName, maxNumLength) + '</a>';
            if(peer.type == 'refer') {
              // display regulars
              for(var j = 0; j < peers.length; ++j) {
                jKey = peers[j];
                if(monitorData.call[callID].peers[jKey].type == 'regular') {
                  peerList += '<a data-value="' + jKey + '"' + (via ? ' title="' + via + '"' : '') +
                    '>' + getUserPart(monitorData.call[callID].peers[jKey].name, maxNumLength) + '</a>';
                }
              }
            }
            var className = 'i';
            if(getKeysCount(monitorData.call[callID].peers) > 1) {
              className = '';
            }
            if(monitorData.group[peer.qName]) {
              sc = $('#mon_' + peer.qName + ' > .turn > span');
            } else if(monitorData.agent[peer.qName]) {
              var qPeer = false;
              for(var j = 0; j < peers.length; ++j) {
                jKey = peers[j];
                if(monitorData.call[callID].peers[jKey].name == peer.qName) {
                  qPeer = true;
                  break;
                }
              }
              if(!qPeer) {
                sc = $('#monContainer li[data-value="' + peer.qName + '"] .i2');
              } else {
                $('#monContainer li[data-value="' + peer.qName + '"] .i2 a[data-value="' + i + '"]').remove();
              }
            }
            if(sc) {
              if(!sc.find('a[data-value="' + i + '"]').length) {
                sc.append('<a data-value="' + i + '" class="' + className + '"' +
                    (via ? ' title="' + via + '"' : '') + '>' +
                    getUserPart(peer.name, maxNumLength) + 
                  '<span class="qTimer"></span></a>'
                );
                busyTimer(sc.find('a[data-value="' + iKey + '"] .qTimer'), peer.tCreated);
                sc.find('a[data-value="' + iKey + '"]').on('click', function() {
                  displayCrmCard($(this).attr('data-value'));
                  $('.turn a.hl').removeClass('hl');
                  $(this).addClass('hl');
                });
              } else {
                sc.find('a[data-value="' + iKey + '"]').attr('class', className).attr('via', via);
              }
            }
          }
        } else {
          if(peer.type == 'refer') {
            if(peer.referredBy) {
              // display referred by
              peerList += '<a data-value="' + peer.referredBy + '"' + (via ? ' title="' + via + '"' : '') +
                '>' + getUserPart(monitorData.call[callID].peers[peer.referredBy].name, maxNumLength) + '</a>';
            } else {
              for(var j = 0; j < peers.length; ++j) {
                jKey = peers[j];
                if(monitorData.call[callID].peers[jKey].name != peer.name && monitorData.call[callID].peers[jKey].type != 'listener') {
                  peerList += '<a data-value="' + jKey + '"' + (via ? ' title="' + via + '"' : '') +
                    '>' +
                    getUserPart(monitorData.call[callID].peers[jKey].name, maxNumLength) + '</a>';
                }
              }
            }
          } else {
            for(var j = 0; j < peers.length; ++j) {
              jKey = peers[j];
              if(monitorData.call[callID].peers[jKey].name != peer.name && monitorData.call[callID].peers[jKey].type != 'listener' && !monitorData.call[callID].peers[jKey].referredBy) {
                peerList += '<a data-value="' + jKey + '"' + (via ? ' title="' + via + '"' : '') +
                  '>' +
                  getUserPart(monitorData.call[callID].peers[jKey].name, maxNumLength) + '</a>';
              } else if(monitorData.call[callID].peers[jKey].name == peer.name) {
                if(monitorData.call[callID].peers[jKey].type == 'callback') {
                  peerList += '<a data-value="' + jKey + '"' + (via ? ' title="' + via + '"' : '') +
                    '>' +
                    getUserPart(monitorData.call[callID].callFrom, maxNumLength) + '</a>';
                } else if(monitorData.call[callID].peers[jKey].type == 'campaign') {
                  peerList += '<a data-value="' + jKey + '"' + (via ? ' title="' + via + '"' : '') +
                    '>' +
                    getUserPart(monitorData.call[callID].callTo, maxNumLength) + '</a>';
                }
              }
            }
          }
          sc = $('#monContainer .turn > span, #monContainer .i2');
          sc.find('a[data-value="' + iKey + '"]').remove();
        }
        if(!peerList && monitorData.call[callID].conferenceHostPeer) {
          peerList = '<a data-value="' + monitorData.call[callID].conferenceHostPeer + '"' + (via ? ' title="' + via + '"' : '') +
            '>' +
            getUserPart(monitorData.call[callID].peers[monitorData.call[callID].conferenceHostPeer].name, maxNumLength) + '</a>';
        }
        if(!ac.find('span[data-value="' + callID + '"]').length) {
          if(!ac.children('span.connected').length && !ac.children('span.out').length && peer.state != 'connecting' && peer.state != 'provisioned') {
            for(var j = 0; j < monitorData.agent[peer.name].groups.length; j++) {
              monitorData.group[monitorData.agent[peer.name].groups[j]].busy++;
              updateMonGroupHead(monitorData.agent[peer.name].groups[j]);
            }
          }
          ac.append('<span class="' + peer.dir +
            (peer.state == 'attached' ? ' connected' : '') +
            '" data-value="' + callID + '">' + peerList +
            '<span class="this"><span class="status">' +
            translate(['peerState', peer.state]) + '</span>' +
            '<span class="busyTime"></span></span>'
          );
          //ac.siblings('.select').hide();
          ac.siblings('.tStatusModified').hide();
          // <cg-agents>
          cgac.find('.call').append(
            '<span class="' + peer.dir +
            (peer.state == 'attached' ? ' connected' : '') +
            '" data-value="' + callID + '">' + peerList + '</span>'
          );
          ac.find('span[data-value="' + callID + '"] a').on('click', function() {
            displayCrmCard($(this).attr('data-value'));
          });
          cgac.find('.icon').removeClass().addClass('icon').addClass(peer.dir).addClass(peer.state == 'attached' ? ' connected' : '');
          cgac.find('.busyTime').attr('data-value', callID);
          cgac.find('.status').attr('data-value', callID);
          cgac.find('.status[data-value="' + callID + '"]').text(translate(['peerState', peer.state]));
          // </cg-agents>
          if(peer.name == sessionParams.name && peer.dir == 'out') {
            openScriptOnCall(peer.script);
          }
        } else {
          if((!monitorData.call[callID].oldPeers || monitorData.call[callID].oldPeers[iKey].state == 'connecting' || monitorData.call[callID].oldPeers[iKey].state == 'provisioned') && peer.state != 'connecting' && peer.state != 'provisioned' && !ac.children('span.connected').length && !ac.children('span.out').length) {
            for(var j = 0; j < monitorData.agent[peer.name].groups.length; j++) {
              monitorData.group[monitorData.agent[peer.name].groups[j]].busy++;
              updateMonGroupHead(monitorData.agent[peer.name].groups[j]);
            }
          }
          if(peer.state == 'attached') {
            ac.find('span[data-value="' + callID + '"]').addClass('connected');
            // <cg-agents>
            cgac.find('.call span[data-value="' + callID + '"]').addClass('connected');
            cgac.find('.icon').addClass('connected');
            // </cg-agents>
            if(peer.name == sessionParams.name && peer.dir == 'in') {
              openScriptOnCall(peer.script);
            }
          }
          ac.find('span[data-value="' + callID + '"] a').remove();
          ac.find('span[data-value="' + callID + '"]').prepend(peerList);
          ac.find('span[data-value="' + callID + '"] a').on('click', function() {
            displayCrmCard($(this).attr('data-value'));
          });
          ac.find('span[data-value="' + callID + '"] .status').text(
            translate(['peerState', peer.state])
          );
          // <cg-agents>
          cgac.find('.call span[data-value="' + callID + '"] a').remove();
          cgac.find('.call span[data-value="' + callID + '"]').prepend(peerList);
          cgac.find('.status[data-value="' + callID + '"]').text(translate(['peerState', peer.state]));
          // </cg-agents>
        }
        if(peer.tConnected && !ac.find('span[data-value="' + callID + '"] .busyTime').text()) {
          busyTimer(ac.find('span[data-value="' + callID + '"] .busyTime'), peer.tConnected);
          // <cg-agents>
          busyTimer(cgac.find('.busyTime[data-value="' + callID + '"]'), peer.tConnected);
          // </cg-agents>
        }
        if(ear) {
          $('#monContainer .items li[data-value="' + peer.name + '"] .listener[data-value="' + ear + '"]').addClass('active').siblings('.active').removeClass('active');
        }
      } else {
        // display other calls
        if(peer.qName) {
          var className = 'i';
          if(getKeysCount(monitorData.call[callID].peers) > 1) {
            className = '';
          }
          if(monitorData.group[peer.qName]) {
            sc = $('#mon_' + peer.qName + ' > .turn > span');
            if(monitorData.group[peer.qName].agents.indexOf(sessionParams.name) >= 0) {
              sc = $('#mon_' + peer.qName + ' > .turn > span, #selfQueue');
            }
          } else if(monitorData.agent[peer.qName]) {
            var qPeer = false;
            for(var j = 0; j < peers.length; ++j) {
              jKey = peers[j];
              if(monitorData.call[callID].peers[jKey].name == peer.qName) {
                qPeer = true;
                break;
              }
            }
            if(!qPeer) {
              sc = $('#monContainer li[data-value="' + peer.qName + '"] .i2');
              if(peer.qName == sessionParams.name) {
                sc = $('#monContainer li[data-value="' + peer.qName + '"] .i2, #selfQueue');
              }
            } else {
              $('#monContainer li[data-value="' + peer.qName + '"] .i2 a[data-value="' + iKey + '"], #selfQueue a[data-value="' + iKey + '"]').remove();
              continue;
            }
          } else {
            return;
          }
          if(!sc.find('a[data-value="' + iKey + '"]').length) {
            $('a[data-value="' + iKey + '"]').remove();
            sc.append('<a data-value="' + iKey + '" class="' + className + '"' +
                (via ? ' title="' + via + '"' : '') +
                '>' +
                getUserPart(peer.name, maxNumLength) + 
              '<span class="qTimer"></span></a>'
            );
            busyTimer(sc.find('a[data-value="' + iKey + '"] .qTimer'), peer.tCreated);
            sc.find('a[data-value="' + iKey + '"]').on('click', function() {
              displayCrmCard($(this).attr('data-value'));
              $('.turn a.hl').removeClass('hl');
              $(this).addClass('hl');
            });
          } else {
            sc.find('a[data-value="' + iKey + '"]').attr('class', className).attr('title', via);
          }
        } else {
          sc = $('#monContainer .turn > span, #monContainer .i2, #selfQueue');
          sc.find('a[data-value="' + iKey + '"]').remove();
        }
      }
    }
  }
}
function updateActionButtons() {
  if(onservice || refer) {
    $('#ahold').addClass('ff0');
  } else {
    $('#ahold').removeClass('ff0');
  }
  if(mute) {
    $('#amute').addClass('ff0');
  } else {
    $('#amute').removeClass('ff0');
  }
}
function adjustGroupHeight(sel) {
  if(!sel.hasClass('active')) return;
  var h = sel.find('.head').outerHeight();
  if(sel.find('#callTableContainer').length) h += $('#callTableContainer').outerHeight();
  if(sel.find('.monAgentFilterContainer').length) h += sel.find('.monAgentFilterContainer').outerHeight();
  if(sel.find('.items').length) h += sel.find('.items').outerHeight();
  if(sel.find('.turn').length) h += sel.find('.turn').outerHeight();
  if(h < 200) h = 210;
  sel.stop().animate({'height':h},500);
}
function setCallMonHandlers() {
  var sel = $('#callGroup');
  sel.children('.head').on('click',function() {
		var t = $(this);
		var li = t.parent();
		if(li.hasClass('active')) {
      $('#callTableContainer').hide();
			t.siblings('.close').stop().fadeOut();
			li.removeClass('active');
			li.stop().animate({'height':t.outerHeight()},500);
		}	else {
			var h = t.outerHeight() + $('#callTableContainer').outerHeight();
			li.addClass('active');
			li.stop().animate({'height':h},700,function(){
				t.stop().siblings('.close').fadeIn();
			});
      $('#callTableContainer').show();
		}
		return false;
	});
  sel.children('.close').on('click',function() {
		if($(this).parent().hasClass('active')) {
      $(this).siblings('.head').trigger('click');
    }
	});
}
function delCallMon(name) {
  var sel = $('#callTableContainer');
  sel.find('p[data-value="' + name + '"]').remove();
  adjustGroupHeight(sel.parent());
}
function updateCallMon(name, callObj) {
  if(!callObj.peers) return;
  var sel = $('#callTableContainer');
  var peerStr = '<span class="cell" data-value="' + name + '" class="monCallId">' + name + '</span>';
  peerStr += '<span class="cell"><span class="qTimer"></span></span>';
  peerStr += '<span class="cell"><a class="rec' +
    (callObj.recording == 'on' || (monitorData.call[name] && monitorData.call[name].recording == 'on') ? '' : ' off') +
    '"></a></span>';
  var firstPeer = null;
  var peers = Object.keys(callObj.peers);
  var iKey;
  for(var i = 0; i < peers.length; ++i) {
    iKey = peers[i];
    var peer = callObj.peers[iKey];
    if(!firstPeer) firstPeer = iKey;
    peerStr += '<span class="cell" data-value="' + iKey + '">' +
      (peer.referredBy ? '<span style="font-weight:bold"> ==> </span>' : '') +
      '<span class="peerName" style="background-color:' + stateToColor(peer.state) + ';' +
      (peer.isAgent ? 'color:white;' : '') +
      '">' +
      getUserPart(peer.name) +
      (peer.state == 'onivr' && peer.ivrName ? ' (' + peer.ivrName + ')' : '') +
      (peer.type == 'listener' ? ' (L)' : '') +
      (peer.type == 'callback' ? ' (C)' : '') +
      (peer.type == 'refer' ? ' (R)' : '') +
      '</span></span> ';
  }
  if(sel.find('p[data-value="' + name + '"]').length) {
    sel.find('p[data-value="' + name + '"]').html(peerStr);
  } else {
    sel.append('<p data-value="' + name + '">' + peerStr + '</p>');
    adjustGroupHeight(sel.parent());
  }
  sel.find('p[data-value="' + name + '"] span.cell').on('click', function() {
    displayCrmCard($(this).attr('data-value'));
  });
  if(callObj.tReg || callObj.peers) {
    busyTimer(sel.find('p[data-value="' + name + '"] .qTimer'),
      callObj.tReg ? callObj.tReg : callObj.peers[firstPeer].tCreated
    );
  }
}
function stateToColor(state) {
  switch(state) {
    case 'attached': return 'seagreen';
    case 'connecting': return 'orange';
    case 'provisioned': return 'orange';
    case 'onservice': return 'blue';
    case 'onhold': return 'blue';
    case 'inqueue': return 'red';
    case 'pending': return 'orange';
    case 'onivr': return 'grey';
    default: return '';
  }
}
function displayCallNoteForm(callID, queueName) {
  if(!callID) return;
  if(!$('#callNotes').length) $('body').append('<div id="callNotes"></div>');
  var sel = $('#callNotes');
  sel.attr('data-value', callID);
  sel.html('<div id="callNotesList"><div id="callNotesTitle">' + translate('callNotes') + '</div><div id="callNotesData"></div></div>' +
    '<div id="callNotesForm"><div id="callNoteFieldsContainer"></div>' +
    '<div><button id="updateCallNotes" class="button ff0 right">' + translate('update') + '</button></div></div>'
  );
  var notes = monitorData.call[callID].notes;
  if(notes) {
    var agents = Object.keys(notes);
    for(var i = 0; i < agents.length; ++i) {
      var tModified = new Date(notes[agents[i]].tModified);
      sel.find('#callNotesData').append(
        '<div class="callNotesByAgent"><div class="callNoteAgentName">'+agents[i]+' ['+tModified.toTimeString().substr(0,8)+']</div>' +
        '<div class="callNotesList"></div></div>'
      );
      var selNotes = sel.find('.callNotesByAgent:last-child .callNotesList');
      var agentNotes = notes[agents[i]].note;
      var noteFields = Object.keys(agentNotes);
      for(var j = 0; j < noteFields.length; ++j) {
        if(noteFields[j] == '') continue;
        selNotes.append('<div class="callNoteField"><p class="callNoteFieldName">' + noteFields[j] + '</p>' +
          '<p class="callNoteFieldValue">' + agentNotes[noteFields[j]] + '</p></div>'
        );
      }
      if(agentNotes['']) selNotes.append('<div class="callNoteField">' +
        '<p class="callNoteFieldName">' + translate('comment') + '</p><p class="callNoteFieldValue">' + agentNotes[''] + '</p></div>'
      );
    }
  }
  if(queueName && monitorData.group[queueName] && monitorData.group[queueName].callNoteFields) { // fill in call note fields
    var fields = monitorData.group[queueName].callNoteFields;
    for(var i = 0; i < fields.length; ++i) {
      var html = '<div class="callNoteFormField"><p class="callNoteFormFieldName">' + fields[i].name + '</p>' +
        '<p class="callNoteFormFieldValue">';
      if(fields[i].type == 'input') html += '<input type="text" class="bg input" name="' + fields[i].name + '" />';
      else if(fields[i].type == 'select') {
        html += '<span class="select"><select name="' + fields[i].name + '">';
        for(var j = 0; j < fields[i].values.length; ++j)
          html += '<option value="' + fields[i].values[j] + '">' + fields[i].values[j] + '</option>';
        html += '</select></span>';
      }
      else continue;
      html += '</p></div>';
      sel.find('#callNoteFieldsContainer').append(html);
    }
  }
  sel.find('#callNoteFieldsContainer').append('<div class="callNoteFormField"><p class="callNoteFormFieldValue">' +
    '<textarea id="callNoteText" class="bg" placeholder="' + translate('comment') + '"></textarea></p></div>'
  );
  sel.find('.select').each(function() {
    select_html($(this));
  });
  sel.find('#updateCallNotes').on('click', function() {
    if(!monitorData.call[callID]) {
      alert('Failed to update call notes: disconnected from call');
      return;
    }
    var noteData = {};
    sel.find('input,select').each(function() {
      noteData[$(this).attr('name')] = $(this).val();
    });
    noteData[''] = sel.find('#callNoteText').val();
    updateCallNotes(callID, noteData);
  });
}
