// ================================================== //
//        Contact Center Chat interface module        //
//                    Version 2.2.5                   //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

var arrayChat = new Array();
var globLines = new Array();
var chatFirstDate = getToday();
var chatSecondDate = getToday();
var chatFirstHour = 0;
var chatSecondHour = 24;
var arrayNotify = {};

function tabChat() {
  var result = '<div class="calendar">' + translate('chatstatsfrom') + ' <span class="date"><i></i><input id="chat_date_from"></span>' +
    ' ' + translate('statsto') + ' <span class="date"><i></i><input id="chat_date_to"></span>' +
    '<button class="bg button ff0">' + translate('request') + '</button></div>' +
    '<div id="chat_slider_time24"><i class="start">0 ' + translate('hours') + '</i>' +
    '<i class="end">24 ' + translate('hours') + '</i></div>' +
    '<form class="filters">' + translate('filters') + ': <span class="input_box bg">' +
    '<input id="filter-chatName" size="12" value="' + translate('chat') + '" data-value="' + translate('chat') + '">' +
    '<i class="reset"></i></span><span class="input_box bg">' +
    '<input id="filter-chatAgentName" size="12" value="' + translate('agent') + '" data-value="' + translate('agent') + '">' +
    '<i class="reset"></i></span><span class="input_box bg">' +
    '<input id="filter-chatCustomerName" size="12" value="' + translate('customer') + '" data-value="' + translate('customer') + '">' +
    '<i class="reset"></i></span></form>' +
    '<ul class="table_tab">' +
    '<li class="bg first">' + translate('settings') + '</li>' +
    '<li class="bg">' + translate('agentstats') + '</li><li class="bg last bg2">' + translate('customerstats') + '</li></ul>' +
    '<div class="tabs"><div id="tabChatSettings" class="tab"><ul class="list_settings clr"></ul></div>' +
    '<div id="tabChatAgentStats" class="tab"><table class="table_stat"><thead><th width="10%">' + translate('date') + '</th><th width="10%">' + translate('time') + '</th>' +
    '<th width="20%">' + translate('chat') + '</th><th width="20%">' + translate('agent') + '</th><th width="20%">' + translate('action') + '</th></thead><tbody></tbody></table></div>' +
    '<div id="tabChatCustomerStats" class="tab active"><table class="table_stat"><thead><th width="10%">' + translate('date') + '</th><th width="10%">' + translate('time') + '</th>' +
    '<th width="20%">' + translate('chat') + '</th><th width="15%">' + translate('agent') + '</th><th width="15%">' + translate('customer') + '</th><th width="20%">' + translate('action') + '</th><th width="10%">' + translate('file') + '</th></thead>' +
    '<tbody></tbody></table></div></div>';
  $('#tabChat').html(result);
  getChats();
}

function setChatHandlers() {
  $('#tabChat .table_tab li').on('click',function() {
		var t = $(this);
		if(t.hasClass('bg2'))
			return false;
		t.addClass('bg2').siblings('.bg2').removeClass('bg2');
		$('#tabChat .tabs .tab').eq(t.index()).addClass('active').siblings('.active').removeClass('active');
    if(!$('#tabChatSettings').hasClass('active')) {
      $('#tabChat .filters').css('visibility', 'visible');
      if($('#tabChatAgentStats').hasClass('active')) {
        $('#filter-chatCustomerName').parent().css('visibility', 'hidden');
      } else {
        $('#filter-chatCustomerName').parent().css('visibility', 'visible');
      }
    } else {
      $('#tabChat .filters').css('visibility', 'hidden');
      $('#filter-chatCustomerName').parent().css('visibility', 'hidden');
    }
    $('#tabChat .input_box .reset').trigger('click');
    $('#tabChat .active .table_stat tr').show();
	});
  $('#tabChat .list_settings .head').on('click',function() {
		var t = $(this);
		var li = t.parent();
		if(li.hasClass('active')){
			t.siblings('.close').stop().fadeOut();
			li.removeClass('active');
			li.stop().animate({'height':t.outerHeight()},500);
		}
		else {
			var h = t.outerHeight() + t.siblings('.items').outerHeight() + t.siblings('.turn').outerHeight() + t.siblings('.detals').outerHeight();
			li.addClass('active');
			li.stop().animate({'height':h},700,function(){
				t.stop().siblings('.close').fadeIn();
			});
		}
		return false;
	});
	$('#tabChat .list_settings .close').on('click',function() {
		$(this).siblings('.head').trigger('click')
	});
  // select 
	$('#tabChat .select').each(function() {
		select_html($(this));
		$(this).children('.value').addClass('bg');
	});
  $('#tabChatSettings button').on('click',function() {
    var index = $(this).attr('id').indexOf('_') + 1;
    updateChatParams($(this).attr('id').substring(index));
  });
  $('.addAdmin, .addMember').on('click', function(e) {
    e.preventDefault();
    var sel = $(this).hasClass('addAdmin') ? '.admins' : '.members';
    var user = prompt(translate('enterusername') + ':');
    if(user && user.length) {
      $(this).siblings(sel).append('<a href="#">' + user + '</a>');
      var index = arrayNotify.length;
      var chat = $(this).parent().parent().attr('id').substring(10);
      arrayNotify[chat].push({ userName: user, action: 'notifyadd' });
      $(this).siblings(sel).children('a:last-child').on('click', function(e) {
        e.preventDefault();
        if(confirm(translate('chataskremove') + ' ' + $(this).text() + ' ' + ($(this).parent().hasClass('admins') ? translate('fromadminlist') : translate('frommemberlist')) + '?')) {
          arrayNotify[chat].splice(index, 1);
          $(this).remove();
        }
      });
    }
  });
  // date
	if ($('#chat_date_from').is('#chat_date_from')) {
		$('#chat_date_from, #chat_date_to').datepicker({
      maxDate: '+0d',
			firstDay: 1,
			dateFormat: 'dd-mm-yy',
			dayNamesMin: translate('daynames'),
			monthNames: translate('monthnames'),
		}).on('change',function(){
			$(this).siblings('i').text($(this).val());
      if(this.id == 'chat_date_from') chatFirstDate = $(this).val();
      else chatSecondDate = $(this).val();
      if(chatFirstDate == chatSecondDate) $('#chat_slider_time24').css('visibility', 'visible');
      else { 
        $('#chat_slider_time24').css('visibility', 'hidden');
        chatFirstHour = 0;
        chatSecondHour = 24;
		    $('#chat_slider_time24').slider({ values: [chatFirstHour, chatSecondHour] });
        $('#chat_slider_time24 .ui-slider-handle').first().text(chatFirstHour);
        $('#chat_slider_time24 .ui-slider-handle').last().text(chatSecondHour);
      }
		});
		$('#tabChat .date i').on('click',function(){
			$(this).siblings('input').trigger('focus');
		});
    var today = new Date();
    $('#chat_date_from').datepicker('setDate', getToday());
    $('#chat_date_to').datepicker('setDate', getToday());
    $('#chat_date_from, #chat_date_to').trigger('change');
    delete today;
	}

  // slider
	if ($('#chat_slider_time24').is('#chat_slider_time24')) {
		$('#chat_slider_time24').slider({
			range: true,
			min: 0,
			max: 24,
			values: [chatFirstHour, chatSecondHour],
			slide: function(event,ui) {
				if(ui.values[0] == ui.values[1])
					return false;
				var handle = $('#chat_slider_time24 .ui-slider-handle');
				handle.first().text(ui.values[0]);
				handle.last().text(ui.values[1]);
        chatFirstHour = ui.values[0];
        chatSecondHour = ui.values[1];
			}
		});
		sep(24,$('#chat_slider_time24'));
    $('#chat_slider_time24 .ui-slider-handle').first().text(chatFirstHour);
    $('#chat_slider_time24 .ui-slider-handle').last().text(chatSecondHour);
	}
  $('#tabChat .input_box .reset').on('click',function(){
		var t = $(this).siblings('input');
		t.val(t.attr('data-value'));
    $('#tabChat .input_box input').trigger('keyup');
	});
	$('#tabChat .input_box input').on('focus',function(){
		var t = $(this);
		if(t.val()==t.attr('data-value'))
			t.val('');
	}).on('blur',function(){
		var t = $(this);
		if(t.val()=='')
			t.val(t.attr('data-value'));
	});
  $('#tabChat .input_box input').on('keyup', function() {
    var f = $('#filter-chatName');
    var fa = $('#filter-chatAgentName');
    var fc = $('#filter-chatCustomerName');
    var chat = (f.val() == f.attr('data-value') || f.val() == '') ? '' : f.val().toLowerCase();
    var agent = (fa.val() == fa.attr('data-value') || fa.val() == '') ? '' : fa.val().toLowerCase();
    var customer = (fc.val() == fc.attr('data-value') || fc.val() == '') ? '' : fc.val().toLowerCase();
    if(chat || agent || customer) {
      $('.active .table_stat tbody tr').each(function() {
        var arrTd = $(this).children();
        if(chat && arrTd.eq(2).text().toLowerCase().indexOf(chat) < 0) { $(this).hide(); return true; }
        if(agent && arrTd.eq(3).text().toLowerCase().indexOf(agent) < 0) { $(this).hide(); return true; }
        if(customer && arrTd.eq(4).text().toLowerCase().indexOf(customer) < 0) { $(this).hide(); return true; }
        $(this).show();
      });
    } else {
      $('.active .table_stat tbody tr').show();
    }
  });
  $('#tabChat .calendar button').on('click', function() {
    $('#tabChat .table_stat tbody').html('');
    for(var i = 0; i < arrayChat.length; i++) {
      getChatStatistic(i);
    }
  });
}

function getMonthPeriod(date) {
  var result = new Object();
  var start = new Date(date);
  start.setDate(1);
  var end = new Date(date);
  end.setDate(1);
  end.setMonth(end.getMonth() + 1);
  result.start = '01-';
  result.end = '01-';
  result.start += (start.getMonth() + 1) < 10 ? '0' + (start.getMonth() + 1) : (start.getMonth() + 1);
  result.end += (end.getMonth() + 1) < 10 ? '0' + (end.getMonth() + 1) : (end.getMonth() + 1);
	result.start += '-' + start.getFullYear();
	result.end += '-' + end.getFullYear();
  return result;
}

function getChats() {
  $.post(
    ccadmin,
    {
      type: 'test-request',
      sessID: sessionId,
      command: 'getChats',
    },
    function(data) {
      var o = $.parseJSON(data);
      arrayChat = o.list;
      for(var i = 0; i < arrayChat.length; i++) {
        writeChatParams(arrayChat[i].chatName);
        propagateChatParams(arrayChat[i].chatName);
        arrayNotify[arrayChat[i].chatName] = [];
        var lines = new Array();
        arrayChat[i].lines = lines;
        getChatStatistic(i);
      }
      setChatHandlers();
    }
  ).fail(function(jqXHR) {
    console.log(jqXHR.status + ', ' + jqXHR.statusText + ', ' + jqXHR.responseText);
    setChatHandlers();
  });
}

function createChatStats() {
  var start = new Date(chatFirstDate.replace(/^(\d{2})\-(\d{2})\-(\d{4})$/, "$3-$2-$1") + 'T' + (chatFirstHour < 10 ? '0' + chatFirstHour : chatFirstHour) + ':00:00');
  var end = new Date(chatSecondDate.replace(/^(\d{2})\-(\d{2})\-(\d{4})$/, "$3-$2-$1") + 'T' + (chatSecondHour < 10 ? '0' + chatSecondHour : (chatSecondHour == 24 ? '23:59:59' : chatSecondHour + ':00:00')));
  globLines = [];
  for(var i = 0; i < arrayChat.length; i++) {
    for(var j = 0; j < arrayChat[i].lines.length; j++) {
      var line = new Object();
      var arrLine = arrayChat[i].lines[j].split(',', 6);
      line.date = arrLine[0];
      line.time = arrLine[1];
      line.datetime = new Date(line.date.replace(/^(\d{2})\-(\d{2})\-(\d{4})$/, "$3-$2-$1") + 'T' + line.time);
      line.agent = arrLine[2];
      line.customer = arrLine[3];
      line.action = arrLine[4];
      line.history = arrLine[5];
      line.chat = arrayChat[i].chatName;
      line.owner = arrayChat[i].ownerName;
      if(line.datetime >= start && line.datetime <= end) globLines.push(line);
    }
  }
  var ad, bd;
  globLines.sort(function(a, b){
    if(a.datetime < b.datetime) return -1;
    if(a.datetime > b.datetime) return 1;
    return 0;
  });
  for(var i = 0; i < globLines.length; i++) {
    var tdClass = '';
    if(/login/.test(globLines[i].action)) tdClass = 'c99';
    if(/finish|left|disconnect|remove/.test(globLines[i].action)) tdClass = 'c69';
    if(/remove/.test(globLines[i].action)) globLines[i].action = 'removed';
    if(globLines[i].customer && !/left/.test(globLines[i].action)) {
      $('#tabChatCustomerStats tbody').append(
        '<tr><td>' + globLines[i].date + '</td><td>' + globLines[i].time + '</td><td>' + globLines[i].chat + '</td>' +
        '<td>' + globLines[i].agent + '</td><td>' + globLines[i].customer + '</td><td class="' + tdClass + '">' + globLines[i].action + (globLines[i].action == 'connect' ? ' to agent' : '') + '</td><td>' + (globLines[i].history ? '<a class="rec" target="_blank" href="/sys/ccadmin.wcgp?command=getChatHistory&sessID=' + sessionId  + '&chatName=' + globLines[i].chat + '&ownerName=' + globLines[i].owner + '&historyDate=' + globLines[i].date + '&customerName=' + globLines[i].customer + '"></a>' : '') + '</td></tr>'
      );
    }
    if(globLines[i].agent && globLines[i].agent != 'chatcenter') {
      $('#tabChatAgentStats tbody').append(
        '<tr><td>' + globLines[i].date + '</td><td>' + globLines[i].time + '</td><td>' + globLines[i].chat + '</td>' +
        '<td>' + globLines[i].agent + '</td><td class="' + tdClass + '">' + globLines[i].action + '</td></tr>'
      );
    }
  }
}

function getChatStatistic(index) {
  $.post(
    ccadmin,
    {
      sessID: sessionId,
      command: 'getChatStatistic',
      chatName: arrayChat[index].chatName,
      ownerName: arrayChat[index].ownerName,
      start: chatFirstDate,
      end: chatSecondDate,
    },
    function(data) {
      arrayChat[index].lines = data.split('\n');
      createChatStats();
      $('#tabChatAgentStats tr').off('click');
      $('#tabChatAgentStats tr').on('click', function() {
        var agent = $(this).children('td').eq(3).text();
        $(this).siblings().each(function() {
          if($(this).children('td').eq(3).text() == agent) $(this).toggleClass('sel');
          else $(this).removeClass('sel');
        });
        $(this).toggleClass('sel');
      });
      $('#tabChatCustomerStats tr').off('click');
      $('#tabChatCustomerStats tr').on('click', function() {
        var customer = $(this).children('td').eq(4).text();
        $(this).siblings().each(function() {
          if($(this).children('td').eq(4).text() == customer) $(this).toggleClass('sel');
          else $(this).removeClass('sel');
        });
        $(this).toggleClass('sel');
      });
    }
  );
}

function writeChatParams(chatName) {
  var result = '<li id="cSettings_' + chatName + '" class="bg"><p class="head bg"><a href="#">' + chatName + '</a></p>' +
    '<ul class="detals clr"><li><p><label>' + translate('canChangeSubject') + '</label><span class="select canChangeSubject">' +
    '<select><option value="">-----</option><option value="on">' + translate('on') + '</option>' +
    '<option value="off">' + translate('off') + '</option></select></span></p><p><label>' + translate('canInvite') + '</label>' +
    '<span class="select canInvite"><select><option value="">-----</option><option value="on">' + translate('on') +
    '</option><option value="off">' + translate('off') + '</option></select></span></p>' +
    '<p><label>' + translate('isLogged') + '</label><span class="select isLogged"><select><option value="">-----</option><option value="on">'
    + translate('on') + '</option><option value="off">' + translate('off') + '</option></select></span></p>' +
    '<p><label>' + translate('welcomeMsg') + '</label><br /><textarea class="welcome chatPrompt"></textarea></p>' +
    //'<p><label>' + translate('detachedShort') + '</label><br /><textarea class="detachedShort chatPrompt"></textarea></p>' +
    //'<p><label>' + translate('detachedLong') + '</label><br /><textarea class="detachedLong chatPrompt"></textarea></p>' +
    '<p><button id="update_' + chatName + '" class="button ff0">' + translate('update') + '</button></p></li><li>' +
    '<p><label>' + translate('customerHistoryMax') + '</label><input class="bg input customerHistoryMax type="text" /></p>' +
    '<p><label>' + translate('historyMax') + '</label><input class="bg input historyMax type="text" /></p>' +
    '<p><label>' + translate('participantsMax') + '</label><input class="bg input participantsMax type="text" /></p>' +
    '<p><label>' + translate('waitingShort') + '</label><br /><textarea class="waitingShort chatPrompt"></textarea></p>' +
    '<p><label>' + translate('waitingLong') + '</label><br /><textarea class="waitingLong chatPrompt"></textarea></p></li></ul>' +
    '<p class="turn"><b>' + translate('admins') + ': </b><span class="admins"></span><a href="#" class="addAdmin yellow border">' + translate('addadmin') + '</a><br />' +
    '<b>' + translate('members') + ': </b><span class="members"></span><a href="#" class="addMember yellow border">' + translate('addmember') + '</a></p>' +
    '<span class="close"></span></li>';
  $('#tabChat .tabs .tab .list_settings').append(result);
}

function propagateChatParams(chatName) {
  $.post(
    ccadmin,
    {
      type: 'test-request',
      sessID: sessionId,
      chatName: chatName,
      command: 'getChatSettings',
    },
    function(data) {
      var o = $.parseJSON(data);
      var ccs = (o.canChangeSubject == 'NO') ? 'off' : 'on';
      var ci = (o.canInvite == 'NO') ? 'off' : 'on';
      var il = (o.isLogged == 'NO') ? 'off' : 'on';
      var chm = o.customerHistoryMax || '';
      var hm = o.historyMax || '';
      var pm = o.participantsMax || '';
      var admins = o.admins;
      var members = o.members;
      var welcome = o.welcome || '';
      //var drl = o.detachedReplyLong || '';
      //var drs = o.detachedReplyShort || '';
      var wss = o.waitingSorryShort || '';
      var wsl = o.waitingSorryLong || '';
      var p = '#cSettings_' + chatName + ' ';
      $(p + '.canChangeSubject select').val(ccs);
      $(p + '.canChangeSubject .value').text($(p + '.canChangeSubject select option[value="'+ccs+'"]').text());
      $(p + '.canInvite select').val(ci);
      $(p + '.canInvite .value').text($(p + '.canInvite select option[value="'+ci+'"]').text());
      $(p + '.isLogged select').val(il);
      $(p + '.isLogged .value').text($(p + '.isLogged select option[value="'+il+'"]').text());
      $(p + '.customerHistoryMax').val(chm);
      $(p + '.historyMax').val(hm);
      $(p + '.participantsMax').val(pm);
      $(p + '.welcome').text(welcome);
      //$(p + '.detachedShort').text(drs);
      //$(p + '.detachedLong').text(drl);
      $(p + '.waitingShort').text(wss);
      $(p + '.waitingLong').text(wsl);
      $(p + '.admins').html('');
      if(admins && admins.length) for(var i = 0; i < admins.length; i++) $(p + '.admins').append('<a href="#">' + admins[i] + '</a>');
      $(p + '.members').html('');
      if(members && members.length) for(var i = 0; i < members.length; i++) $(p + '.members').append('<a href="#">' + members[i] + '</a>');
      $(p + '.admins a, ' + p + '.members a').on('click', function(e) {
        e.preventDefault();
        if(confirm(translate('chataskremove') + ' ' + $(this).text() + ' ' + ($(this).parent().hasClass('admins') ? translate('fromadminlist') : translate('frommemberlist')) + '?')) {
          arrayNotify[chatName].push({ userName: $(this).text(), action: 'notifyremove' });
          $(this).remove();
        }
      });
    }
  ).fail(function(jqXHR) {
    alert(jqXHR.status + ', ' + jqXHR.statusText + ', ' + jqXHR.responseText);
  });
}

function updateChatParams(chatName) {
  var p = '#cSettings_' + chatName + ' ';
  createOverlay();
  var adminList = new Array();
  var memberList = new Array();
  $(p + '.admins a').each(function() {
    adminList.push($(this).text());
  });
  $(p + '.members a').each(function() {
    memberList.push($(this).text());
  });
  $.post(
    ccadmin,
    {
      type: 'test-request',
      sessID: sessionId,
      chatName: chatName,
      command: 'setChatSettings',

      canChangeSubject: ($(p + '.canChangeSubject select').val() == 'on' ? 'YES' : 'NO'),
      canInvite: ($(p + '.canInvite select').val() == 'on' ? 'YES' : 'NO'),
      isLogged: ($(p + '.isLogged select').val() == 'on' ? 'YES' : 'NO'),
      customerHistoryMax: $(p + '.customerHistoryMax').val(),
      historyMax: $(p + '.historyMax').val(),
      participantsMax: $(p + '.participantsMax').val(),
      welcome: $(p + '.welcome').val(),
      //detachedReplyShort: $(p + '.detachedShort').val(),
      //detachedReplyLong: $(p + '.detachedLong').val(),
      waitingSorryShort: $(p + '.waitingShort').val(),
      waitingSorryLong: $(p + '.waitingLong').val(),
      admins: adminList,
      members: memberList,
    },
    function() {
      notifyUsers(chatName);
      arrayNotify[chatName] = [];
      propagateChatParams(chatName);
      setTimeout(function() { closeOverlay(); }, 1000);
    }
  ).fail(function(jqXHR) {
    alert(jqXHR.status + ', ' + jqXHR.statusText + ', ' + jqXHR.responseText);
  });
}

function notifyUsers(chatName) {
  for(var i = 0; i < arrayNotify[chatName].length; i++) {
    $.post(
      ccadmin,
      {
        type: 'test-request',
        sessID: sessionId,
        command: 'notifyChatMember',
        content: translate(arrayNotify[chatName][i].action) + ' ' + chatName + '@' + domainName,
        userName: arrayNotify[chatName][i].userName,
      }
    );
  }
}
