// ================================================== //
//       Contact Center Users interface module        //
//                   Version 2.2.5                    //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

var queueList;
var groups = [];
var agents = [];
var curUser;
var recordDefault = 'No';
var dummyAgentSettings = {
  queueSettings: {},
  extensions: [],
  pty: {},
  skill: {},
  access: {
    admin: [],
    control: [],
    monitor: [],
  },
};
var accountDefaults = {};

function listUsers() {
  $('#tabUsers').html(
    (sessionParams.ccHiddenModules && sessionParams.ccHiddenModules.indexOf('settings_users_create') >= 0 ? '' :
    '<div class="right onethirdwidth bg standheight"><ul id="newUser"><li id="userNew"><div>' +
    '<h2>' + translate('createaccount') + '</h2><br />' +
    '<p><label>' + translate('accountid') + '</label><br><input class="userID bg input" type="text" size="15" />' +
    '<label> @' + domainName + '</label></p><br />' +
    '<p><label>' + translate('realname') + '</label><br /><input class="userRealName bg input" type="text" /></p>' +
    '<p><label>' + translate('pass') + '</label><br /><input class="userPass bg input" type="password" /></p>' +
    '<p><label>' + translate('queueextension') + '</label><br /><input class="userAlias bg input" type="text" /></p>' +
    '<br /><p><label>' + translate('role') + '</label><br /><span class="settingContainer">' +
    '<input type="radio" name="roleNew" value="" checked="checked" />&nbsp;' + translate('none') +
    '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +
    '<input type="radio" name="roleNew" value="agent" />&nbsp;' + translate('agent') + '</span></p>' +
    '<p><label>' + translate('recordstatistics') + '</label><br />' +
    '<table width="100%"><tr>' +
    '<td width="50%">' + make_select('yesno', 'recStats', '', recordDefault) + '</td>' +
    //'<td width="50%"><a class="rec' + (recordDefault == 'Yes' ? '' : ' off') + '"></a></td></tr></table></p>' +
    '<td width="50%"></td></tr></table></p>' +
    '<br /><table width="100%"><tr><td>' +
    '<button id="create_account" class="button ff0">' + translate('create') + '</button></td></tr></table>' +
    '</div></li></ul></div>') +
    '<div class="left twothirdwidth bg standheight"><ul id="selUser"><li id="userList"><div>' +
    '<h2>' + translate('accountlist') + ' ' + domainName + '</h2><br><div><div></div></div>' +
    '<table width="100%" cellspacing="0" cellpadding="0" style="margin-top:10px">' +
    '<tr><td width="50%" align="right">' + translate('recordstatistics') + '<br />(' +
    translate('domainDefaults') + ')</td>' +
    '<td width="50%" align="center"><span class="select">' +
    '<select class="recStatsDefault">' +
    '<option value="Yes"' + (recordDefault == 'Yes' ? ' selected="selected"' : '') + '>' +
    translate('yes') + '</option>' +
    '<option value="No"' + (recordDefault == 'No' ? ' selected="selected"' : '') + '>' +
    translate('no') + '</option>' +
    '</select></span></td></tr></table></div></li>' +
    '<li id="userInfo"><div><h2>' + translate('editaccount') +  '</h2></div></li></ul></div>'
  );
  adjustInputSize($('#userNew'));
  select_html($('.recStatsDefault').parent());
  $('.recStatsDefault').on('change', function() {
    updateUserDefaults({ PSTNRecord: $(this).val().toUpperCase() });
  });
  // create user
  $('#userNew .button').on('click', function() {
    createOverlay();
    var validationResult = validateUserInfo($('#userNew'));
    if(validationResult.error) {
      alert(validationResult.errorText);
      closeOverlay();
      return;
    }
    var ai = validationResult.accountInfo;
    createUser(ai.userName, ai);
    $('#userNew').on('userCreated', function() {
      curUser = ai.userName;
      if(ai.roleNew) {
        var settings = dummyAgentSettings;
        settings.realName = ai.RealName;
        settings.extensions = ai.alias;
        createObject('agent', ai.userName, settings);
      } else if(ai.alias.length) {
        updateUserAliases(ai.userName, ai.alias);
      }
      listUsers();
    });
  });
  // end create user
  var userList = $('#userList > div > div > div');
  userList.html('<div class="loader"></div>');
	$('#userNew .select').each(function() {
	  select_html($(this));
	  $(this).children('.value').addClass('bg');
	});
  /*
  $('#userNew .recStats').on('change', function() {
    if($(this).val() == 'Yes') {
      $('#userNew .rec').removeClass('off');
    } else if($(this).val() == 'No'){
      $('#userNew .rec').addClass('off');
    } else {
      if(recordDefault == 'Yes') {
        $('#userNew .rec').removeClass('off');
      } else {
        $('#userNew .rec').addClass('off');
      }
    }
  });
  */
  getAgents();
  $('#userList').on('gotAgents', function() {
    getUsers();
  });
}

function displayUserList(list) {
  var userList = $('#userList > div > div > div');
  userList.html('');
  if(list.length) {
    var icon;
    var st;
    var greyList = [];
    var j = 0;
    for(var i = 0; i < list.length; i++) {
      if(isArrElem(list[i], groups) || list[i] == 'pbx' || list[i] == 'postmaster') {
        if(list[i] == 'pbx' || list[i] == 'postmaster') greyList.push(list[i]);
        continue;
      } else {
        if(isArrElem(list[i], agents)) {
          st = monitorData.agent[list[i]] ? monitorData.agent[list[i]].status : 'off';
        } else st = null;
        if(st) icon = '<img alt="" src="' + filesRef + 'cc_agent_' + (st == 'off' ? 'off' : 'on') + '.svg" />'; else icon = '';
        userList.append(
          '<p id="user_' + list[i] + '" class="pointer">' +
          '<a><i>' + (j + 1) + '.</i> ' + list[i] + icon + '</a></p>'
        );
        j++;
      }
    }
    for(var i = 0; i < groups.length; i++) {
      userList.append(
        '<p><a class="pointer"><i>' + (j + 1) + '. ' +
        groups[i] + '<span class="right">' + translate('queue') + '</span></i></a></p>'
      );
      j++;
    }
    for(var i = 0; i < greyList.length; i++) {
      userList.append('<p><a class="pointer"><i>' + (j + 1) + '. ' + greyList[i] + '</i></a></p>');
      j++;
    }
    var jspElem = userList.parent().jScrollPane();
    jspApi = jspElem.data('jsp');
    // get user info
    $('#userList div p').on('click', function(e) {
      e.preventDefault();
      if(!this.id) return;
      if(!$(this).hasClass('bg')) {
        $(this).addClass('bg').siblings('.bg').removeClass('bg');
      }
      var userName = this.id.substring(5); // 'user_'.length = 5
      var isAgent = isArrElem(userName, agents);
      getUserInfo(userName);
      $('#userInfo').html('<div><h2>' + translate('editaccount') + '</h2><br>' +
        '<p><label>' + translate('accountid') + '</label><br />' +
        '<input class="userID bg input" type="text" value="' + userName + '" disabled="disabled" size="15" />' +
        '<label> @' + domainName + '</label></p><br />' +
        '<p><label>' + translate('realname') + '</label><br />' +
        '<input class="userRealName bg input" type="text" /></p>' +
        '<p><label>' + translate('pass') + '</label><br />' +
        '<input class="userPass bg input" type="password" value="********"></p>' +
        '<p><label>' + translate('queueextension') + '</label><br />' +
        '<input class="userAlias bg input" type="text" /></p><br />' +
        '<p><label>' + translate('role') + '</label><br /><span class="settingContainer">' +
        '<input type="radio" name="role" value=""' +
        (!isAgent ? ' checked="checked"' : '') + ' />&nbsp;' + translate('none') +
        '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="radio" name="role" value="agent"' +
        (isAgent ? ' checked="checked"' : '') + ' />&nbsp;' + translate('agent') +
        (isAgent ? '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' +
        '<a class="aSettings pointer grey border">' + translate('settings') + '</a>' : '') + '</span></p>' +
        '<p><label>' + translate('recordstatistics') + '</label><br />' +
        '<table width="100%"><tr>' +
        '<td width="50%">' + make_select('yesno', 'recStats', '', translate(recordDefault)) + '</td>' +
        //'<td width="50%"><a class="rec' + (recordDefault == 'Yes' ? '' : ' off') + '"></a></td></tr></table></p>' +
        '<td width="50%"></td></tr></table></p>' +
        '<br /><table width="100%"><tr><td>' +
        '<button id="update_user" class="button ff0">' + translate('update') + '</button></td>' +
        '<td><button id="remove_user" class="button bg">' + translate('remove') + '</button>' +
        '</td></tr></table></div>');
      adjustInputSize($('#userInfo'));
      $('#userInfo .select').each(function() {
        select_html($(this));
        $(this).children('.value').addClass('bg');
      });
      /*
      $('#userInfo .recStats').on('change', function() {
        if($(this).val() == 'Yes') {
          $('#userInfo .rec').removeClass('off');
        } else if($(this).val() == 'No'){
          $('#userInfo .rec').addClass('off');
        } else {
          if(recordDefault == 'Yes') {
            $('#userInfo .rec').removeClass('off');
          } else {
            $('#userInfo .rec').addClass('off');
          }
        }
      });
      */
      $('#userInfo .aSettings').on('click', function() {
        $('#tabUsers').append(
          '<div class="agentSettings bg standheight left twothirdwidth">' +
          '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
          '<div class="loader"></div></div>'
        );
        $('.agentSettings .closeIcon').on('click', function() {
          $(this).parent().remove();
        });
        getSettings('agent', userName);
      });
      // remove user
      $('#remove_user').on('click',function() {
        //alert(translate('actionremoveblocked'));
        if(confirm(translate('askremove') + ' ' + userName + '?')) {
          removeUser(userName);
          $('#userInfo').on('userRemoved', function() {
            listUsers();
          });
        }
      });
      // end remove user
      // update user
      $('#update_user').on('click',function() {
        curUser = userName;
        createOverlay();
        var validationResult = validateUserInfo($('#userInfo'));
        if(validationResult.error) {
          alert(validationResult.errorText);
          closeOverlay();
          return;
        }
        var ai = validationResult.accountInfo;
        var isAgent = isArrElem(userName, agents);
        if(confirm(translate('askupdate') + ' ' + userName + '@' + domainName + '?')) {
          if(ai.role == 'agent' && !isAgent) {
            var settings = dummyAgentSettings;
            if(ai.RealName) {
              settings.realName = ai.RealName;
            }
            settings.extensions = ai.alias;
            createObject('agent', userName, settings);
            $('#userInfo').on('objCreated', function() {
              //updateUserAliases(userName, ai.alias);
              delete ai.RealName;
              delete ai.alias;
              delete ai.role;
              delete ai.roleNew;
              delete ai.userName;
              updateUserInfo(userName, ai);
            });
          } else if(!ai.role && isAgent) {
            removeObject('agent', userName);
            $('#userInfo').on('objRemoved', function() {
              updateUserAliases(userName, ai.alias);
              delete ai.alias;
              delete ai.role;
              delete ai.roleNew;
              delete ai.userName;
              updateUserInfo(userName, ai);
            });
          } else {
            if(isAgent) {
              var settings = {};
              if(ai.RealName) {
                settings.realName = ai.RealName;
              }
              settings.extensions = ai.alias;
              updateSettings('agent', userName, settings);
            } else {
              updateUserAliases(userName, ai.alias);
            }
            delete ai.alias;
            delete ai.role;
            delete ai.roleNew;
            delete ai.userName;
            updateUserInfo(userName, ai);
          }
        } else {
          closeOverlay();
        }
      });
      // end update user
    });
    // end get user info
    if(curUser) {
      $('#user_' + curUser).trigger('click');
      curUser = null;
    }
    closeOverlay();
  }
}

function displayUserInfo(s) {
  var sel = $('#userInfo');
  if(s.RealName) {
    sel.find('.userRealName').val(s.RealName);
  }
  if(s.PSTNRecord) {
    sel.find('.recStats').val(s.PSTNRecord.toUpperCase()).trigger('change');
  }
  if(s.aliases) {
    sel.find('.userAlias').val(s.aliases);
  } else {
    if(s.AccessModes) {
      if(s.AccessModes.indexOf('All') >= 0) {
        return;
      }
      if(s.AccessModes.indexOf('Signal') >= 0 && (s.AccessModes.indexOf('SIP') >= 0 || s.AccessModes.indexOf('XIMSS') >= 0)) {
        return;
      }
      sel.find('input[name="role"]').attr('disabled', true);
    } else {
      if(accountDefaults.AccessModes) {
        if(accountDefaults.AccessModes.indexOf('All') >= 0) {
          return;
        }
        if(accountDefaults.AccessModes.indexOf('Signal') >= 0 && (accountDefaults.AccessModes.indexOf('SIP') >= 0 || accountDefaults.AccessModes.indexOf('XIMSS') >= 0)) {
          return;
        }
        sel.find('input[name="role"]').attr('disabled', true);
      }
    }
  }
}

function validateUserInfo(elem) {
  var result = new Object;
  var accountInfo = new Object;
  result.error = false;
  accountInfo.userName = elem.find('.userID').val().toLowerCase();
  if(!accountInfo.userName) {
    result.error = true;
    result.errorText = translate('wrongid');
    return result;
  }
  accountInfo.RealName = elem.find('.userRealName').val();
  accountInfo.Password = elem.find('.userPass').val();
  if(!accountInfo.Password) {
    result.error = true;
    result.errorText = translate('wrongpass');
    return result;
  }
  if(accountInfo.Password == '********') delete accountInfo.Password;
  accountInfo.alias = elem.find('.userAlias').val();
  if(accountInfo.alias != '') {
    accountInfo.alias = accountInfo.alias.replace(/\s+/g, '');
    accountInfo.alias = accountInfo.alias.split(',');
  } else {
    accountInfo.alias = [];
  }
  accountInfo.role = elem.find('input[name="role"]:checked').val();
  accountInfo.roleNew = elem.find('input[name="roleNew"]:checked').val();
  accountInfo.PSTNRecord = elem.find('.recStats').val();
  //if(accountInfo.PSTNRecord == 'Yes') accountInfo.PSTNRecord = 'YES';
  //else if(accountInfo.PSTNRecord == 'No') accountInfo.PSTNRecord = 'NO';
  //else accountInfo.PSTNRecord = '';
  result.accountInfo = accountInfo;
  return result;
}

function adjustInputSize(elem) {
  if(!elem.length) return;
  var contWidth = elem.children('div').width();
  var id = elem.find('.userID input');
  var padLeft = id.css('padding-left') || 0;
  if(padLeft) padLeft = +padLeft.substring(0,padLeft.indexOf('px'));
  var padRight = id.css('padding-right') || 0;
  if(padRight) padRight = +padRight.substring(0,padRight.indexOf('px'));
  var idLabelWidth = id.siblings('label').eq(1).width();
  var idWidth = ((contWidth - idLabelWidth - padLeft - padRight) * 0.67).toFixed(); // 2/3 correction
  id.width(idWidth);
  var input = id.parent().siblings('p').children('input');
  var inputWidth = ((contWidth - padLeft - padRight) * 0.67).toFixed(); // 2/3 correction
  input.each(function() {
    $(this).width(inputWidth);
  });
}

function isArrElem(elem, arr) {
  for(var i = 0; i < arr.length; i++) {
    if(arr[i] == elem) return true;
  }
  return false;
}

function objCreated() {
  $('#userInfo').trigger('objCreated');
  $('.queueSettings').trigger('objCreated');
}

function objRemoved() {
  $('#userInfo').trigger('objRemoved');
  $('.queueSettings').trigger('objRemoved');
}

function gotAgents() {
  $('#userList').trigger('gotAgents');
}

function userCreated() {
  $('#userNew').trigger('userCreated');
  $('.queueSettings').trigger('userCreated');
}

function userRemoved() {
  $('#userInfo').trigger('userRemoved');
}

